// DlgImagineElf_Pattern_Material.cpp : implementation file
//

#include "stdafx.h"

#include "DlgSampleTexture.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CDlgSampleTexture dialog


CDlgSampleTexture::CDlgSampleTexture(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgSampleTexture::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgSampleTexture)
	m_BmpFile = _T("");
	m_Name = _T("");
	myObj=NULL;

    //m_h_bitmap = static_cast<HBITMAP>(LoadImage (theApp.m_hInstance, MAKEINTRESOURCE(IDB_Arrow),
				//					IMAGE_BITMAP, 0, 0, LR_LOADMAP3DCOLORS));

}

void CDlgSampleTexture::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgSampleTexture)
	DDX_Control(pDX, IDC_Texture, m_Texture);
	DDX_Text(pDX, IDC_BmpFile, m_BmpFile);
	DDX_Text(pDX, IDC_Name, m_Name);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgSampleTexture, CDialog)
	//{{AFX_MSG_MAP(CDlgSampleTexture)
	ON_WM_CTLCOLOR()
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_EN_KILLFOCUS(IDC_Name, OnKillfocusName)
	ON_BN_CLICKED(IDC_Texture, OnTexture)
	ON_BN_CLICKED(IDC_cmdCOLOR, OncmdCOLOR)
	ON_BN_CLICKED(IDC_BrowseFile, OnBrowseFile)
	ON_WM_VSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgSampleTexture message handlers

BOOL CDlgSampleTexture::OnInitDialog() 
{
	CDialog::OnInitDialog();

	myObj=NULL;
    m_COLOR = ON_Color(255,255,255);
    OnBrush(m_COLOR);
    //OnTexture();

	GetDlgItem(IDC_BrowseFile)->EnableWindow(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CDlgSampleTexture::PreTranslateMessage(MSG* pMsg) 
{
/*  switch (pMsg->message)
  {
    case WM_KEYDOWN:

      switch (pMsg->wParam)
      {
        case VK_RETURN:
		{
		  if (GetDlgItem(IDC_Angle) == GetFocus())
		    OnKillfocusAngle();
		}
		default :
		  return FALSE;
	  }
	  NextFocus();
	  break;
  }
  return CDialog::PreTranslateMessage(pMsg);*/
  return FALSE;
}

BOOL CDlgSampleTexture::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	switch( HIWORD(wParam) )
	{
	  case EN_KILLFOCUS:   //edit box
		  {
		    aKillControlWnd = FromHandle((HWND)lParam);
	        aKillControlWnd->Invalidate();
		    break;
		  }
	   case EN_SETFOCUS:
		   {
		     aSetControlWnd = FromHandle((HWND)lParam);
			 Focus = aSetControlWnd->GetDlgCtrlID();
	         aSetControlWnd->Invalidate();
			 break;
		   }
	  case CBN_KILLFOCUS:  //combo box
		  {
		    aKillControlWnd = FromHandle((HWND)lParam);
			break;
		  }
	  case CBN_SETFOCUS:
		  {
			aSetControlWnd = FromHandle((HWND)lParam);
			break;
		  }
	  default:
		  {
			if (FromHandle((HWND)lParam) == GetDlgItem(IDOK))
			{
//			  aSetControlWnd = FromHandle((HWND)lParam);
			}
			break;
		  }
	}		
	
	return CDialog::OnCommand(wParam, lParam);
}

void CDlgSampleTexture::PostNcDestroy() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CDialog::PostNcDestroy();
}

HBRUSH CDlgSampleTexture::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
  if (pWnd==NULL)
	return bkBrush;
  HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
  int id=pWnd->GetDlgCtrlID();
/*if (ID==IDC_Name || ID==IDC_Angle || ID == IDC_ScaleX || ID == IDC_ScaleY )
  {
	pDC->SetBkMode(TRANSPARENT);
	if (GetDlgItem(ID) == GetFocus())
	  hbr = BlueBrush;
	else
	  hbr = bkBrush;
  }
  else if (ID==IDC_Color)*/
  if (id==IDC_Color)
  {
	pDC->SetBkMode(TRANSPARENT);
	if (GetDlgItem(id) == GetFocus())
 	  hbr=(HBRUSH)mybrush.GetSafeHandle();
	else hbr=(HBRUSH)mybrush.GetSafeHandle();
  }
  return hbr;
}

void CDlgSampleTexture::OnPaint() 
{
  if (IsIconic())
  {
	  CPaintDC dc(this); // device context for painting
	  SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
	  // Center icon in client rectangle
	  int cxIcon = GetSystemMetrics(SM_CXICON);
	  int cyIcon = GetSystemMetrics(SM_CYICON);
	  CRect rect;
	  GetClientRect(&rect);
	  int x = (rect.Width() - cxIcon + 1) / 2;
	  int y = (rect.Height() - cyIcon + 1) / 2;
	  // Draw the icon
	  dc.DrawIcon(x, y, m_hIcon);
  }
  else
  {
	  CDialog::OnPaint();
  }
}

void CDlgSampleTexture::OnSize(UINT nType, int cx, int cy) 
{
	CWnd* pWndToCenterOn=CWnd::FromHandle(RhinoApp().MainWnd());
	if (pWndToCenterOn == NULL)
      return;

	CRect rectToCenterOn;
    pWndToCenterOn->GetWindowRect(&rectToCenterOn);

	CRect rectSubDialog;
    GetWindowRect(&rectSubDialog);

	int xLeft = rectToCenterOn.right - rectSubDialog.Width()-5;
    int yTop = rectToCenterOn.top+30;
	SetWindowPos(NULL, xLeft, yTop, -1, -1,
        SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
	
}

void CDlgSampleTexture::OnKillfocusName() 
{
  UpdateData(TRUE);
  UpdateObj();
}

void CDlgSampleTexture::OnTexture() 
{
  if(m_Texture.GetCheck() == 0)
  {
	if(GetDlgItem(IDC_BrowseFile)->IsWindowEnabled())	GetDlgItem(IDC_BrowseFile)->EnableWindow(FALSE);

	if(m_BmpFile != "")
	{
	  m_BmpFile="";
	  UpdateData(FALSE);
	}
  }
  else // == 1
  {
	if(!GetDlgItem(IDC_BrowseFile)->IsWindowEnabled())	GetDlgItem(IDC_BrowseFile)->EnableWindow(TRUE);

  }
  UpdateObj();
}

void CDlgSampleTexture::OncmdCOLOR() 
{
  ON_Color color=m_COLOR;
  if(RhinoColorDialogEx(::RhinoApp().MainWnd(),color))
    OnBrush(color);
  UpdateObj();
}

void CDlgSampleTexture::OnBrowseFile() 
{
  CRhinoGetFileDialog GetFileDlg;
  GetFileDlg.DisplayFileDialog(CRhinoGetFileDialog::open_bitmap_dialog,ON_wString(m_BmpFile));
  m_BmpFile=GetFileDlg.FileName();
  UpdateData(FALSE);
  NextFocus();
  UpdateObj();
}

void CDlgSampleTexture::UpdateObj()
{
  if (!myObj) return;

  const auto doc_serial = CRhinoDoc::ModelessUserInterfaceDocSerialNumber();
  auto* pDoc = CRhinoDoc::FromRuntimeSerialNumber(doc_serial);
  if (pDoc == nullptr)
    return;

  int material_index = myObj->Attributes().m_material_index;

  // There are no attribute and material on the object
  // So it want to add attribute and material with no bitmap texture to the object
  if (material_index == -1)
  {
    if (m_BmpFile == L"")
    {
      const CRhinoObjectAttributes&  A = myObj->Attributes();
      CRhinoObjectAttributes A2(A);
      ON_Material Material;
      Material.SetDiffuse(m_COLOR);
      if (m_Name != L"")
      {
        A2.m_name = m_Name; // NOTE: This is setting the name of the object which is different to the name of the material.
        Material.SetName(m_Name);
      }

      if (A2.MaterialSource() != ON::object_material_source::material_from_object)
      {
        // Create a custom (basic) RDK material and attach it to the document.
        auto* pMaterial = ::RhRdkNewBasicMaterial(Material, pDoc);
        auto& contents = pDoc->Contents().BeginChange(RhRdkChangeContext::UI);
        contents.Attach(*pMaterial);
        contents.EndChange();

        // Make the material table's material use the custom RDK material.
        Material.SetRdkMaterialInstanceId(pMaterial->InstanceId());
        Material.SetMaterialPlugInId(uuidUniversalRenderEngine); // This is critical when using the RDK material.

        const int id = pDoc->m_material_table.AddMaterial(Material);
        A2.m_color = m_COLOR;
        A2.SetColorSource(ON::color_from_object);
        A2.SetMaterialSource(ON::material_from_object);
        A2.m_material_index = id;

        CRhinoObjRef objRef(myObj);
        pDoc->ModifyObjectAttributes(objRef,A2);
      }
    }
  }
  else if (m_Texture.GetCheck() == BST_UNCHECKED)
  {
    // Turn the bitmap child slot off and delete the texture.
    auto* pMaterial = pDoc->Contents().Find(myObj->ObjectMaterial().RdkMaterialInstanceId());
    if (pMaterial != nullptr)
    {
      auto& m = pMaterial->BeginChange(RhRdkChangeContext::UI);
      m.SetChildSlotOn(CS_MAT_BITMAP_TEXTURE, false);
      m.SetChild(nullptr, CS_MAT_BITMAP_TEXTURE);
      m.EndChange();
    }
  }
  else if (m_BmpFile != L"")
  {
    // The object has a material so it wants to add or modify the bitmap texture on the material.

    // Find the RDK material.
    ON_Material Material = myObj->ObjectMaterial();
    auto* pMaterial = pDoc->Contents().Find(Material.RdkMaterialInstanceId());
    if (pMaterial != nullptr)
    {
      // Find the material's child bitmap texture.
      const auto* pTexture = pMaterial->FindChild(CS_MAT_BITMAP_TEXTURE);
      if (pTexture == nullptr)
      {
        // Texture not found; create it and set it as a child of the material.
        CRhRdkSimulatedTexture tex;
        pTexture = ::RhRdkNewBitmapTexture(tex, pDoc);
        auto& m = pMaterial->BeginChange(RhRdkChangeContext::UI);
        m.SetChild(pTexture, CS_MAT_BITMAP_TEXTURE);
        m.EndChange();
      }

      if (pTexture != nullptr)
      {
        auto currentFileName = pTexture->GetParameter(FS_TEX_FILENAME).AsString();
        if (currentFileName != m_BmpFile)
        {
          // Make the operation undoable.
          CRhRdkContentUndo cu(*pDoc);
          cu.ModifyContent(*pMaterial);

          // Begin the change operation.
          auto& texture = pTexture->BeginChange(RhRdkChangeContext::UI);

          // Set the child texture's file name.
          const wchar_t* filename = m_BmpFile;
          texture.SetParameter(FS_TEX_FILENAME, filename);

          // Set the name of the material from the file name.
          ON_wString sName;
          ON_FileSystemPath::SplitPath(m_BmpFile, nullptr, nullptr, &sName, nullptr);
          texture.SetInstanceName(sName);

          // End the change operation.
          texture.EndChange();

          if (!pMaterial->ChildSlotOn(CS_MAT_BITMAP_TEXTURE))
          {
            // Turn the bitmap child slot on.
            auto& m = pMaterial->BeginChange(RhRdkChangeContext::UI);
            m.SetChildSlotOn(CS_MAT_BITMAP_TEXTURE, true);
            m.EndChange();
          }
        }
      }
    }
  }

  // Always modify the color and name if either has changed.
  bool IsModify = false;

  const auto& A = myObj->Attributes();
  CRhinoObjectAttributes A2(A); // This is only needed if you really want to set the object name and display color.

  const auto& Material = myObj->ObjectMaterial();

  if (ON_wString(m_Name) != Material.Name())
  {
    A2.m_name = m_Name; // NOTE: This is setting the name of the object which is different to the name of the material.
    IsModify = true;
  }

  if (Material.Diffuse() != m_COLOR)
  {
    A2.m_color = m_COLOR; // NOTE: This is setting the display color of the object which is different to the material color.
    IsModify = true;
  }

  if (IsModify)
  {
    auto* pMaterial = pDoc->Contents().Find(Material.RdkMaterialInstanceId());
    if (pMaterial != nullptr)
    {
      // Setting the name and color of the RDK material will automatically set the material table's material as well.
      auto& m = pMaterial->BeginChange(RhRdkChangeContext::UI);
      m.SetInstanceName(m_Name);
      m.SetParameter(FS_MAT_DIFFUSE, ON_Color(m_COLOR));
      m.EndChange();
    }

    CRhinoObjRef objRef(myObj);
    pDoc->ModifyObjectAttributes(objRef, A2); // This is only needed if you really want to set the object name and display color.
  }

  pDoc->Regen();
}


void CDlgSampleTexture::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
  if (nSBCode == SB_ENDSCROLL)
	return;

  CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}


void CDlgSampleTexture::SetWindowTitle(CString& title)
{  SetWindowText(title);	}


void CDlgSampleTexture::NextFocus()
{
  UpdateData(TRUE);
}

void CDlgSampleTexture::OnCancel() 
{
  int a = 1;
  DestroyWindow();
}

void CDlgSampleTexture::GetObj(const CRhinoObject* obj)
{
  if (!obj) return;
  myObj = obj;

  int material_index = obj->Attributes().m_material_index;

  // the object no material
  if (material_index == -1)
    return;

  ON_Material material = obj->ObjectMaterial();
  const auto doc_serial = CRhinoDoc::ModelessUserInterfaceDocSerialNumber();
  auto* pDoc = CRhinoDoc::FromRuntimeSerialNumber(doc_serial);
  // Find the RDK material.
  auto* pMaterial = pDoc->Contents().Find(material.RdkMaterialInstanceId());

  //Find Name
  m_Name = CString(obj->Attributes().m_name);

  //Find Color
  m_COLOR = material.Diffuse();
  mybrush.DeleteObject();
  mybrush.CreateSolidBrush(m_COLOR);
  GetDlgItem(IDC_Color)->Invalidate();
  GetDlgItem(IDC_Color)->SetFocus();

  //Find Texture Status
  const ON_Material Material = obj->ObjectMaterial();
  m_BmpFile = L"";
  int id = Material.FindTexture(NULL, ON_Texture::TYPE::bitmap_texture);
  if (id >= 0) m_BmpFile = Material.m_textures.At(id)->m_image_file_reference.FullPath();

  UpdateData(FALSE);

  if (m_BmpFile != "") m_Texture.SetCheck(1);
  else m_Texture.SetCheck(0);
  OnTexture();

}

void CDlgSampleTexture::OnBrush(ON_Color color)
{
  mybrush.DeleteObject();
  m_COLOR = color;
  mybrush.CreateSolidBrush(m_COLOR);
  GetDlgItem(IDC_Color)->Invalidate();
  GetDlgItem(IDC_Color)->SetFocus();
}
